/***************************************************************************
                          game.cpp  -  description
                             -------------------
    begin                : Tue Feb 12 2002
    copyright            : (C) 2002 by funthing (Matthias Zisler)
    email                : matthias@zislers.de
 ***************************************************************************/

/***************************************************************************
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 ***************************************************************************/

#include "game.h"
#include "global_types.h"
#include "auriferous.h"
#include "jukebox.h"
#include "menu.h"
#include "resources.h"
#include "gameobject.h"
#include "timer.h"
#include "config.h"
#include "button.h"
#include "map_sample.h"
#include "player.h"
#include "map.h"

Game::Game(Auriferous* _app)
{
	app=_app;
	must_end=false;
	showmen=false;
	CL_MouseCursor::hide();
	yes=new Button(632, 400, app->menu, "Yes");
	no=new Button(380, 368, app->menu, "No (continue)");
	timer=new Timer;
}
Game::~Game()
{
	delete timer;
}
void Game::run(bool players)
{
	t=players;

	sample=new Map_Sample(this);

	while(!must_end)
	{
		timer->reset();
		CL_Display::clear_display();
		act_game();
		show_game();
		draw_game_gui();
		draw_hud();
		CL_Display::flip_display();			
		CL_System::keep_alive();
		while (timer->time_elapsed() < (1.0f/60.0f))
			CL_System::sleep(1);
	}

	yes->set_Delete_Me();
	no->set_Delete_Me();
}
bool Game::get_t()
{
	return t;
}
void Game::draw_hud()
{
  Resources::Rfontg()->print_center(512, 0, Config::get_last_levelset()+": "+(CL_String)(sample->get_id()+1));

	if(t)
	{
		switch(sample->p2->get_own())
		{
			case TBEFUDLEMENTGAS:
				Resources::Tiles()->put_screen(934, 726, 54);		
			break;
			case TBIGBOMB:
				Resources::Tiles()->put_screen(934, 726, 67);
			break;
			case TCBOMB:
				Resources::Tiles()->put_screen(934, 726, 68);	
			break;
			case TPICKAXE:
				Resources::Tiles()->put_screen(934, 726, 48);	
			break;
			case TSLIMEBUCKET:
				Resources::Tiles()->put_screen(934, 726, 50);	
			break;
			case TEXPLODER:
				Resources::Tiles()->put_screen(934, 726, 52);	
			break;
			case TTRAP:
				Resources::Tiles()->put_screen(934, 726, 55);		
			break;
			case TJACKHAMMER:
				Resources::Tiles()->put_screen(934, 726, 56);		
			break;
			case TSYRINGE:
				Resources::Tiles()->put_screen(934, 726, 57);		
			break;
			case TLASERTRIPMINE:
				Resources::Tiles()->put_screen(934, 726, 58);		
			break;
			case TACID:
				Resources::Tiles()->put_screen(934, 726, 59);		
			break;
			case TKEYRED:
				Resources::Tiles()->put_screen(934, 726, 49);		
			break;
			case TKEYGREEN:
				Resources::Tiles()->put_screen(934, 726, 51);		
			break;
 		}

		for(int i=0; i<sample->p2->get_bombs(); i++)	
		Resources::Tiles()->put_screen(902-i*20, 726, 66);		

	
		Resources::Tiles()->put_screen(758, 726, 53);
		Resources::Gfont()->print_right(760, 736, (CL_String)(sample->p2->get_lives()));

		Resources::Tiles()->put_screen(648, 726, 82);
		Resources::Rfontg()->print_right(647, 734, (CL_String)(sample->p2->get_score()));
	}

	switch(sample->p1->get_own())
	{
		case TBEFUDLEMENTGAS:
			Resources::Tiles()->put_screen(56, 726, 54);		
		break;
		case TBIGBOMB:
			Resources::Tiles()->put_screen(56, 726, 67);
		break;
		case TCBOMB:
			Resources::Tiles()->put_screen(56, 726, 68);	
		break;
		case TPICKAXE:
			Resources::Tiles()->put_screen(56, 726, 48);	
		break;
		case TSLIMEBUCKET:
			Resources::Tiles()->put_screen(56, 726, 50);	
		break;
		case TEXPLODER:
			Resources::Tiles()->put_screen(56, 726, 52);	
		break;
		case TTRAP:
			Resources::Tiles()->put_screen(56, 726, 55);		
		break;
		case TJACKHAMMER:
			Resources::Tiles()->put_screen(56, 726, 56);		
		break;
		case TSYRINGE:
			Resources::Tiles()->put_screen(56, 726, 57);		
		break;
		case TLASERTRIPMINE:
			Resources::Tiles()->put_screen(56, 726, 58);		
		break;
		case TACID:
			Resources::Tiles()->put_screen(56, 726, 59);		
		break;
		case TKEYRED:
			Resources::Tiles()->put_screen(56, 726, 49);		
		break;
		case TKEYGREEN:
			Resources::Tiles()->put_screen(56, 726, 51);		
		break;
 	}	

	Resources::Tiles()->put_screen(228, 726, 53);
	Resources::Gfont()->print_left(258, 736, (CL_String)(sample->p1->get_lives()));

	Resources::Tiles()->put_screen(340, 726, 82);
	Resources::Rfontg()->print_left(374, 734, (CL_String)(sample->p1->get_score()));

	for(int i=0; i<sample->p1->get_bombs(); i++)	
	Resources::Tiles()->put_screen(88+i*20, 726, 66);
}
void Game::draw_game_gui()
{
	Resources::Gameframe()->put_screen(0, 0);

	if(Config::get_fps()==true)
	app->menu->draw_fps();

	if(CL_Keyboard::get_keycode(CL_KEY_ESCAPE)==true)
	{
		CL_MouseCursor::set_cursor(Resources::Cursor());
		showmen=true;
	}

	if(showmen==true)
	{
		show_dialog();
		app->menu->actshowgui();
	}
}
void Game::act_game()
{
		sample->act(); //act all!

		if(sample->no_left())
		{
			if(Config::get_last_levelset()=="default")
			play_outro();

			must_end=true;
		}

	if(t)
	{
		if(sample->p1->get_lives()<=0 && sample->p2->get_lives()<=0)
		must_end=true;
	}
	else
	{
		if(sample->p1->get_lives()<=0)
		must_end=true;
	}
}
void Game::show_game()
{
 	sample->show();
}
void Game::show_dialog()
{
	if(yes->is_pressed()==true)
	{
		must_end=true; //here ends your game then!
	}

	if(no->is_pressed()==true)
	{
		showmen=false;
		CL_MouseCursor::hide();
	}

	Resources::Gfont()->print_center(512, 336, "Should this Game quited?");
}
void Game::play_outro()
{
	int i=135;
	CL_Surface* sur;
	Resources::Speed()->play();

	while(CL_Keyboard::get_keycode(CL_KEY_ESCAPE) != true)
	{
		CL_Display::clear_display();

		if(i<10)
		{
			sur=CL_JPEGProvider::create(Resources::datapath+"pics/menu/intro/intro000"+(CL_String)(i)+".jpg", NULL);
		}
		else if(i<100)
		{
			sur=CL_JPEGProvider::create(Resources::datapath+"pics/menu/intro/intro00"+(CL_String)(i)+".jpg", NULL);

			if(i==75)
			Resources::Speed()->play();
			else if(i==25)
			Resources::Speed()->play();
		}
		else
		{
 			sur=CL_JPEGProvider::create(Resources::datapath+"pics/menu/intro/intro0"+(CL_String)(i)+".jpg", NULL);
  	}

		sur->put_screen(352, 256);
		Resources::Gfont()->print_center(512, 200, "Congratulations, you've done your job!");

		if(sur)
		delete sur;

		if(i>1)
		i--;
		else
		break;

  	CL_Display::flip_display();			
		CL_System::keep_alive();
 	}
	Resources::Teleport()->play();
}